//+------------------------------------------------------------------+
//|                                                        Entry.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
extern double Risk_to_Reward = 2;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectsDeleteAll();     
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {   
  }
//+------------------------------------------------------------------+
//| On chart event                                                   |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         // Event identifier   
                  const long& lparam,   // Event parameter of long type 
                  const double& dparam, // Event parameter of double type 
                  const string& sparam) // Event parameter of string type 
 
  
  {
   static ulong clickTimeMemory;
   
   if(id == CHARTEVENT_CLICK)
   { 
    ulong clickTime = GetTickCount();
    if(clickTime < clickTimeMemory + 300)
    {
     ChartClean();
     
     datetime time = 0;
     double price = 0;
     int window = 0;
     if (ChartXYToTimePrice(ChartID(),int(lparam),int(dparam),window,time,price))
      {        
       int bar = iBarShift(Symbol(),Period(),time);     
       double HighPrice = iHigh(Symbol(),Period(),bar);       
       datetime StartTime = iTime(Symbol(),Period(),bar);
       
       ObjectCreate("EntryRectText", OBJ_RECTANGLE,0, StartTime, HighPrice, StartTime+PeriodSeconds()*25, HighPrice+(10*Point));
       ObjectSet("EntryRectText",OBJPROP_BACK,true);
       ObjectSetInteger(0,"EntryRectText",OBJPROP_SELECTABLE,false); 
       ObjectSetInteger(0,"EntryRectText",OBJPROP_SELECTED,false);                 
       ObjectSetInteger(0, "EntryRectText",OBJPROP_COLOR,C'0,161,0');       
      }    
       clickTimeMemory = 0;
    }
       else
       clickTimeMemory = clickTime;    
   }
       else if(id == CHARTEVENT_MOUSE_MOVE){}
       else if(id == CHARTEVENT_KEYDOWN)
   {
       return;
   }
  }

  
//+------------------------------------------------------------------+
//| Chart clean                                                      |
//+------------------------------------------------------------------+  
void ChartClean()
 {   
  ObjectDelete("EntryRectText");   
  Comment("");
 }  